#!/usr/bin/env dart
import 'package:disposable/disposable.dart';

main() {
  final multiDisposable = new MultiAssignmentDisposable();

  final d1 = new Disposable.create(() {
    print('one');
  });

  multiDisposable.disposable = d1;

  final d2 = new Disposable.create(() {
    print('two');
  });

  multiDisposable.disposable = d2;

  d2.dispose();
  // => two

  print(d1.isDisposed);
  // => false

  print(d2.isDisposed);
  // => true
}
