#!/usr/bin/env dart
import 'package:disposable/disposable.dart';

main() {
  final serialDisposable = new SerialDisposable();

  final d1 = new Disposable.create(() {
    print('one');
  });

  serialDisposable.disposable = d1;

  final d2 = new Disposable.create(() {
    print('two');
  });

  serialDisposable.disposable = d2;
  // => one

  serialDisposable.dispose();
  // => two
}
