#!/usr/bin/env dart
import 'package:disposable/disposable.dart';

main() {
  final singleDisposable = new SingleAssignmentDisposable();

  final d1 = new Disposable.create(() {
    print('one');
  });

  singleDisposable.disposable = d1;

  final d2 = new Disposable.create(() {
    print('two');
  });

  try {
    singleDisposable.disposable = d2;
  } on StateError catch (e) {
    print(e.message);
    // => Disposable has already been assigned
  }
}
