#!/usr/bin/env dart
import 'package:disposable/disposable.dart';

main() {
  final d1 = new Disposable.create(() {
    print('one');
  });

  final d2 = new Disposable.create(() {
    print('two');
  });

  final disposables = new CompositeDisposable.from([d1, d2]);

  disposables.dispose();
  // => one
  // => two
}
